## mongodb 2.0.0

=== SConstruct ===
# -*- mode: python; -*-
# build file for MongoDB
# this requires scons
# you can get from http://www.scons.org
# then just type scons

# some common tasks
#   build 64-bit mac and pushing to s3
#      scons --64 s3dist
#      scons --distname=0.8 s3dist
#      all s3 pushes require settings.py and simples3

EnsureSConsVersion(0, 98, 4) # this is a common version known to work

import os
import sys
import imp
import types
import re
import shutil
import urllib
import urllib2
import buildscripts
import buildscripts.bb
import stat
from buildscripts import utils

buildscripts.bb.checkOk()

def findSettingsSetup():
    sys.path.append( "." )
    sys.path.append( ".." )
    sys.path.append( "../../" )

# --- options ----

options = {}

options_topass = {}

def add_option( name, help , nargs , contibutesToVariantDir , dest=None ):

    if dest is None:
        dest = name

    AddOption( "--" + name , 
               dest=dest,
               type="string",
               nargs=nargs,
               action="store",
               help=help )

    options[name] = { "help" : help ,
                      "nargs" : nargs , 
                      "contibutesToVariantDir" : contibutesToVariantDir ,
                      "dest" : dest } 

def get_option( name ):
    return GetOption( name )

def _has_option( name ):
    x = get_option( name )
    if x is None:
        return False

    if x == False:
        return False

    if x == "":
        return False

    return True

def has_option( name ):
    x = _has_option(name)
    options_topass[name] = x
    return x


def get_variant_dir():
    
    a = []
    
    for name in options:
        o = options[name]
        if not has_option( o["dest"] ):
            continue
        if not o["contibutesToVariantDir"]:
            continue
        
        if o["nargs"] == 0:
            a.append( name )
        else:
            a.append( name + "-" + get_option( name ) )

    s = "build/"

    if len(a) > 0:
        a.sort()
        s += "/".join( a ) + "/"
        
    return s
        


# installation/packaging
add_option( "prefix" , "installation prefix" , 1 , False )
add_option( "distname" , "dist name (0.8.0)" , 1 , False )
add_option( "distmod", "additional piece for full dist name" , 1 , False )
add_option( "nostrip", "do not strip installed binaries" , 0 , False )

add_option( "sharedclient", "build a libmongoclient.so/.dll" , 0 , False )
add_option( "full", "include client and headers when doing scons install", 0 , False )

# linking options
add_option( "release" , "release build" , 0 , True )
add_option( "static" , "fully static build" , 0 , True )

# base compile flags
add_option( "64" , "whether to force 64 bit" , 0 , True , "force64" )
add_option( "32" , "whether to force 32 bit" , 0 , True , "force32" )

add_option( "cxx", "compiler to use" , 1 , True )
add_option( "cc", "compiler to use for c" , 1 , True )

add_option( "cpppath", "Include path if you have headers in a nonstandard directory" , 1 , True )
add_option( "libpath", "Library path if you have libraries in a nonstandard directory" , 1 , True )

add_option( "extrapath", "comma separated list of add'l paths  (--extrapath /opt/foo/,/foo) static linking" , 1 , True )
add_option( "extrapathdyn", "comma separated list of add'l paths  (--extrapath /opt/foo/,/foo) dynamic linking" , 1 , True )
add_option( "extralib", "comma separated list of libraries  (--extralib js_static,readline" , 1 , True )
add_option( "staticlib", "comma separated list of libs to link statically (--staticlib js_static,boost_program_options-mt,..." , 1 , True )
add_option( "staticlibpath", "comma separated list of dirs to search for staticlib arguments" , 1 , True )

add_option( "boost-compiler", "compiler used for boost (gcc41)" , 1 , True , "boostCompiler" )
add_option( "boost-version", "boost version for linking(1_38)" , 1 , True , "boostVersion" )

# experimental features
add_option( "mm", "use main memory instead of memory mapped files" , 0 , True )
add_option( "asio" , "Use Asynchronous IO (NOT READY YET)" , 0 , True )
add_option( "ssl" , "Enable SSL" , 0 , True )

# library choices
add_option( "usesm" , "use spider monkey for javascript" , 0 , True )
add_option( "usev8" , "use v8 for javascript" , 0 , True )

# mongo feature options
add_option( "noshell", "don't build shell" , 0 , True )
add_option( "safeshell", "don't let shell scripts run programs (still, don't run untrusted scripts)" , 0 , True )
add_option( "win2008plus", "use newer operating system API features" , 0 , False )

# dev tools
add_option( "d", "debug build no optimization, etc..." , 0 , True , "debugBuild" )
add_option( "dd", "debug build no optimization, additional debug logging, etc..." , 0 , False , "debugBuildAndLogging" )
add_option( "durableDefaultOn" , "have durable default to on" , 0 , True )
add_option( "durableDefaultOff" , "have durable default to off" , 0 , True )

add_option( "pch" , "use precompiled headers to speed up the build (experimental)" , 0 , True , "usePCH" )
add_option( "distcc" , "use distcc for distributing builds" , 0 , False )
add_option( "clang" , "use clang++ rather than g++ (experimental)" , 0 , True )

# debugging/profiling help

# to use CPUPROFILE=/tmp/profile
# to view pprof -gv mongod /tmp/profile
add_option( "pg", "link against profiler" , 0 , False , "profile" )
add_option( "tcmalloc" , "link against tcmalloc" , 0 , False )
add_option( "gdbserver" , "build in gdb server support" , 0 , True )
add_option( "heapcheck", "link to heap-checking malloc-lib and look for memory leaks during tests" , 0 , False )

add_option("smokedbprefix", "prefix to dbpath et al. for smoke tests", 1 , False )

# --- environment setup ---

def removeIfInList( lst , thing ):
    if thing in lst:
        lst.remove( thing )

def printLocalInfo():
    import sys, SCons
    print( "scons version: " + SCons.__version__ )
    print( "python version: " + " ".join( [ `i` for i in sys.version_info ] ) )

printLocalInfo()

boostLibs = [ "thread" , "filesystem" , "program_options" ]

onlyServer = len( COMMAND_LINE_TARGETS ) == 0 or ( len( COMMAND_LINE_TARGETS ) == 1 and str( COMMAND_LINE_TARGETS[0] ) in [ "mongod" , "mongos" , "test" ] )
nix = False
linux = False
linux64  = False
darwin = False
windows = False
freebsd = False
openbsd = False
solaris = False
force64 = has_option( "force64" )
if not force64 and os.getcwd().endswith( "mongo-64" ):
    force64 = True
    print( "*** assuming you want a 64-bit build b/c of directory *** " )
msarch = None
if force64:
    msarch = "amd64"

force32 = has_option( "force32" ) 
release = has_option( "release" )
static = has_option( "static" )

debugBuild = has_option( "debugBuild" ) or has_option( "debugBuildAndLogging" ) 
debugLogging = has_option( "debugBuildAndLogging" )
noshell = has_option( "noshell" ) 

usesm = has_option( "usesm" )
usev8 = has_option( "usev8" ) 

asio = has_option( "asio" )

usePCH = has_option( "usePCH" )

justClientLib = (COMMAND_LINE_TARGETS == ['mongoclient'])

env = Environment( MSVS_ARCH=msarch , tools = ["default", "gch"], toolpath = '.' )
if has_option( "cxx" ):
    env["CC"] = get_option( "cxx" )
    env["CXX"] = get_option( "cxx" )
elif has_option("clang"):
    env["CC"] = 'clang'
    env["CXX"] = 'clang++'

if has_option( "cc" ):
    env["CC"] = get_option( "cc" )

env["LIBPATH"] = []

if has_option( "libpath" ):
    env["LIBPATH"] = [get_option( "libpath" )]

if has_option( "cpppath" ):
    env["CPPPATH"] = [get_option( "cpppath" )]

env.Append( CPPDEFINES=[ "_SCONS" , "MONGO_EXPOSE_MACROS" ] )
env.Append( CPPPATH=[ "." ] )

if has_option( "safeshell" ):
    env.Append( CPPDEFINES=[ "MONGO_SAFE_SHELL" ] )

if has_option( "durableDefaultOn" ):
    env.Append( CPPDEFINES=[ "_DURABLEDEFAULTON" ] )

if has_option( "durableDefaultOff" ):
    env.Append( CPPDEFINES=[ "_DURABLEDEFAULTOFF" ] )

boostCompiler = GetOption( "boostCompiler" )
if boostCompiler is None:
    boostCompiler = ""
else:
    boostCompiler = "-" + boostCompiler

boostVersion = GetOption( "boostVersion" )
if boostVersion is None:
    boostVersion = ""
else:
    boostVersion = "-" + boostVersion

if ( not ( usesm or usev8 or justClientLib) ):
    usesm = True
    options_topass["usesm"] = True

distBuild = len( COMMAND_LINE_TARGETS ) == 1 and ( str( COMMAND_LINE_TARGETS[0] ) == "s3dist" or str( COMMAND_LINE_TARGETS[0] ) == "dist" )

extraLibPlaces = []

def addExtraLibs( s ):
    for x in s.split(","):
        env.Append( CPPPATH=[ x + "/include" ] )
        env.Append( LIBPATH=[ x + "/lib" ] )
        env.Append( LIBPATH=[ x + "/lib64" ] )
        extraLibPlaces.append( x + "/lib" )

if has_option( "extrapath" ):
    addExtraLibs( GetOption( "extrapath" ) )
    release = True # this is so we force using .a

if has_option( "extrapathdyn" ):
    addExtraLibs( GetOption( "extrapathdyn" ) )

if has_option( "extralib" ):
    for x in GetOption( "extralib" ).split( "," ):
        env.Append( LIBS=[ x ] )

class InstallSetup:
    binaries = False
    clientSrc = False
    headers = False
    bannerDir = None
    headerRoot = "include"

    def __init__(self):
        self.default()
    
    def default(self):
        self.binaries = True
        self.libraries = False
        self.clientSrc = False
        self.headers = False
        self.bannerDir = None
        self.headerRoot = "include"
        self.clientTestsDir = None

    def justClient(self):
        self.binaries = False
        self.libraries = False
        self.clientSrc = True
        self.headers = True
        self.bannerDir = "distsrc/client/"
        self.headerRoot = ""
        self.clientTestsDir = "client/examples/"
        
installSetup = InstallSetup()
if distBuild:
    installSetup.bannerDir = "distsrc"

if has_option( "full" ):
    installSetup.headers = True
    installSetup.libraries = True


# ------    SOURCE FILE SETUP -----------

commonFiles = Split( "pch.cpp buildinfo.cpp db/indexkey.cpp db/jsobj.cpp bson/oid.cpp db/json.cpp db/lasterror.cpp db/nonce.cpp db/queryutil.cpp db/querypattern.cpp db/projection.cpp shell/mongo.cpp db/security_common.cpp db/security_commands.cpp" )
commonFiles += [ "util/background.cpp" , "util/util.cpp" , "util/file_allocator.cpp" ,
                 "util/assert_util.cpp" , "util/log.cpp" , "util/ramlog.cpp" , "util/md5main.cpp" , "util/base64.cpp", "util/concurrency/vars.cpp", "util/concurrency/task.cpp", "util/debug_util.cpp",
                 "util/concurrency/thread_pool.cpp", "util/password.cpp", "util/version.cpp", "util/signal_handlers.cpp",  
                 "util/histogram.cpp", "util/concurrency/spin_lock.cpp", "util/text.cpp" , "util/stringutils.cpp" ,
                 "util/concurrency/synchronization.cpp" ]
commonFiles += [ "util/net/sock.cpp" , "util/net/httpclient.cpp" , "util/net/message.cpp" , "util/net/message_port.cpp" , "util/net/listen.cpp" ]
commonFiles += Glob( "util/*.c" ) 
commonFiles += Split( "client/connpool.cpp client/dbclient.cpp client/dbclient_rs.cpp client/dbclientcursor.cpp client/model.cpp client/syncclusterconnection.cpp client/distlock.cpp s/shardconnection.cpp" )

#mmap stuff

coreDbFiles = [ "db/commands.cpp" ]
coreServerFiles = [ "util/net/message_server_port.cpp" , 
                    "client/parallel.cpp" , "db/common.cpp", 
                    "util/net/miniwebserver.cpp" , "db/dbwebserver.cpp" , 
                    "db/matcher.cpp" , "db/dbcommands_generic.cpp" , "db/dbmessage.cpp" ]

mmapFiles = [ "util/mmap.cpp" ]

if has_option( "mm" ):
    mmapFiles += [ "util/mmap_mm.cpp" ]
elif os.sys.platform == "win32":
    mmapFiles += [ "util/mmap_win.cpp" ]
else:
    mmapFiles += [ "util/mmap_posix.cpp" ]

coreServerFiles += mmapFiles

processInfoFiles = [ "util/processinfo.cpp" ]

if os.path.exists( "util/processinfo_" + os.sys.platform + ".cpp" ):
    processInfoFiles += [ "util/processinfo_" + os.sys.platform + ".cpp" ]
elif os.sys.platform == "linux3":
    processInfoFiles += [ "util/processinfo_linux2.cpp" ]
else:

=== distsrc/client/SConstruct ===
# scons file for MongoDB c++ client library and examples

import os

# options 
AddOption( "--extrapath",
           dest="extrapath",
           type="string",
           nargs=1,
           action="store",
           help="comma separated list of add'l paths  (--extrapath /opt/foo/,/foo) static linking" )

AddOption( "--prefix",
           dest="prefix",
           type="string",
           nargs=1,
           action="store",
           default="/usr/local",
           help="installation root" )


env = Environment( MSVS_ARCH=None )

def addExtraLibs( s ):
    for x in s.split(","):
        if os.path.exists( x ):
            env.Append( CPPPATH=[ x + "/include" ] )
            env.Append( LIBPATH=[ x + "/lib" ] )
            env.Append( LIBPATH=[ x + "/lib64" ] )

if GetOption( "extrapath" ) is not None:
    addExtraLibs( GetOption( "extrapath" ) )

env.Append( CPPPATH=[ "mongo/" ] )

env.Append( CPPDEFINES=[ "_SCONS" , "MONGO_EXPOSE_MACROS" ] )

nix = False
linux = False

if "darwin" == os.sys.platform:
    addExtraLibs( "/opt/local/" )
    nix = True
elif "linux2" == os.sys.platform or "linux3" == os.sys.platform:
    nix = True
    linux = True

if nix:
    env.Append( CPPFLAGS=" -O3" )
    env.Append( LIBS=["pthread"] )
if linux:
    env.Append( LINKFLAGS=" -Wl,--as-needed -Wl,-zdefs " )

boostLibs = [ "thread" , "filesystem" , "system", "thread" ]
conf = Configure(env)
for lib in boostLibs:
    if not conf.CheckLib("boost_%s-mt" % lib):
        conf.CheckLib("boost_%s" % lib)

dirs = [ "" , "bson/" , "bson/util/" , 
         "client/"  , "s/" , "shell/" , 
         "db/" , 
         "scripting/" , 
         "util/" , "util/concurrency/" , "util/mongoutils/" , "util/net/" ]

allClientFiles = []
for x in dirs:
    allClientFiles += Glob( "mongo/" + x + "*.cpp" )
allClientFiles += Glob( "mongo/util/*.c" )

libs = []
libs += env.SharedLibrary( "mongoclient" , allClientFiles )
libs += env.Library( "mongoclient" , allClientFiles )

# install

prefix = GetOption( "prefix" )

for x in libs:
    env.Install( prefix + "/lib/" , str(x) )

for x in dirs:
    x = "mongo/" + x
    env.Install( prefix + "/include/" + x , Glob( x + "*.h" ) )

env.Alias( "install" , prefix )


# example setup

clientTests = []
clientEnv = env.Clone();
clientEnv.Prepend( LIBS=["libmongoclient.a"])
clientEnv.Prepend( LIBPATH=["."] )

# examples

clientTests += [ clientEnv.Program( "firstExample" , [ "client/examples/first.cpp" ] ) ]
clientTests += [ clientEnv.Program( "secondExample" , [ "client/examples/second.cpp" ] ) ]
clientTests += [ clientEnv.Program( "whereExample" , [ "client/examples/whereExample.cpp" ] ) ]
clientTests += [ clientEnv.Program( "authTest" , [ "client/examples/authTest.cpp" ] ) ]
clientTests += [ clientEnv.Program( "httpClientTest" , [ "client/examples/httpClientTest.cpp" ] ) ]
clientTests += [ clientEnv.Program( "clientTest" , [ "client/examples/clientTest.cpp" ] ) ]
clientEnv.Alias("clientTests", clientTests, [])

=== debian/changelog ===
mongodb (1:2.0.0-2~bpo60+1) squeeze-backports; urgency=low

  * Backport to squeeze
  * Update scons build-dependency to >= 2.1 (backported as well)
  * Remove gcc 4.6 specific "no-error" flag, which breaks on gcc 4.4

 -- Guido Trotter <ultrotter@debian.org>  Fri, 14 Oct 2011 16:16:19 +0100

mongodb (1:2.0.0-2) unstable; urgency=low

  * need to reupload package to get it build on i386 which failed because of
    cdbs error

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sun, 25 Sep 2011 20:22:08 +0200

mongodb (1:2.0.0-1) unstable; urgency=low

  * New upstream release 2.0.0 (Closes: #641646)
    http://blog.mongodb.org/post/10126837729/mongodb-2-0-released
  * proper Spider Monkey is embedded (Closes: #637370, #572870, #631054)
  * currently linking against system libpcre3

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Wed, 14 Sep 2011 17:09:16 +0200

mongodb (1:1.8.3-1) unstable; urgency=low

  * New upstream release 1.8.3
    https://jira.mongodb.org/browse/SERVER/fixforversion/10390

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Tue, 23 Aug 2011 08:48:57 +0200

mongodb (1:1.8.2-2) unstable; urgency=low

  * [2e1c3ff] (Closes: #625401) ignore unused-but-set-{variable,parameter}
  * [0e9611d] (Closes: #572870, #631054) switch to v8 as javascript engine
  * [bbf5935] (Closes: #634484) use dbpath and logpath from config file
    not forcing in init.d
  * [bf8d466] update description
  * [cbe2d99] Imported Upstream version 1.8.3

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Tue, 23 Aug 2011 08:48:17 +0200

=== debian/control ===
Source: mongodb
Section: database
Priority: optional
Maintainer: Antonin Kral <A.Kral@sh.cvut.cz>
Uploaders: Roberto C. Sanchez <roberto@connexer.com>, Jérémy Lal <kapouer@melix.org>
Build-Depends: debhelper (>= 7), cdbs (>= 0.4.73~), libpcre3, libpcre3-dev, scons (>= 2.1), libreadline-dev, libboost-dev, libboost-thread-dev, libboost-filesystem-dev, libboost-program-options-dev, libboost-date-time-dev, python-pymongo
Standards-Version: 3.9.2
Vcs-Git: git://github.com/bobek/mongo-debian.git
Vcs-Browser: https://github.com/bobek/mongo-debian
Homepage: http://www.mongodb.org

Package: mongodb
Architecture: i386 amd64
Depends: mongodb-server, mongodb-dev, ${shlibs:Depends}, ${misc:Depends}
Description: object/document-oriented database (metapackage)
 MongoDB is a high-performance, open source, schema-free
 document-oriented  data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features :
 .
    * Collection oriented storage - easy storage of object-
      style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large
      objects (e.g. videos)
    * Auto-sharding for cloud-level scalability (Q209)
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This is a metapackage that depends on all the mongodb parts.

Package: mongodb-server
Architecture: i386 amd64
Depends: mongodb-clients, ${shlibs:Depends}, ${misc:Depends}, adduser
Description: object/document-oriented database (server package)
 MongoDB is a high-performance, open source, schema-free
 document-oriented  data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features :
 .
    * Collection oriented storage - easy storage of object-
      style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large
      objects (e.g. videos)
    * Auto-sharding for cloud-level scalability (Q209)
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the server itself.

Package: mongodb-clients
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: object/document-oriented database (client apps)
 MongoDB is a high-performance, open source, schema-free
 document-oriented  data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features :
 .
    * Collection oriented storage - easy storage of object-
      style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large
      objects (e.g. videos)
    * Auto-sharding for cloud-level scalability (Q209)
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the various client applications.

Package: mongodb-dev
Section: libdevel
Architecture: i386 amd64
Depends: mongodb-server, libboost-dev, ${shlibs:Depends}, ${misc:Depends}
Description: object/document-oriented database (development)
 MongoDB is a high-performance, open source, schema-free
 document-oriented  data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features :
 .
    * Collection oriented storage - easy storage of object-
      style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large
      objects (e.g. videos)
    * Auto-sharding for cloud-level scalability (Q209)
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 Development headers and libraries.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/scons.mk
include /usr/share/cdbs/1/rules/debhelper.mk

DEB_DH_INSTALLINIT_ARGS = --name=mongodb

DEB_SCONS_OPTIONS := 
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif

DEB_SCONS_BUILD_TARGET = all
DEB_SCONS_INSTALL_OPTIONS += --prefix=$(CURDIR)/debian/tmp/usr --full
DEB_SCONS_CHECK_TARGET = --smokedbprefix=$(CURDIR)/debian/tmp-test smoke

clean::
	find . -name "*.pyc" -delete
	rm -f buildinfo.cpp
	rm -rf debian/tmp-test

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

# examination of the downloads page content as the directory listing is not allowed anymore
# Forced regexp to match only to the current stable release
http://www.mongodb.org/display/DOCS/Downloads \
  http://.*mongodb\.org/src/mongodb-src-r(1\.6[\d\.]+)\.tar\.gz

## mongodb 2.0.2

=== SConstruct ===
--- 
+++ 
@@ -31,6 +31,16 @@
     sys.path.append( "." )
     sys.path.append( ".." )
     sys.path.append( "../../" )
+
+def getThirdPartyShortNames():
+    lst = []
+    for x in os.listdir( "third_party" ):
+        if not x.endswith( ".py" ) or x.find( "#" ) >= 0:
+            continue
+         
+        lst.append( x.rpartition( "." )[0] )
+    return lst
+
 
 # --- options ----
 
@@ -135,6 +145,8 @@
 add_option( "boost-compiler", "compiler used for boost (gcc41)" , 1 , True , "boostCompiler" )
 add_option( "boost-version", "boost version for linking(1_38)" , 1 , True , "boostVersion" )
 
+add_option( "no-glibc-check" , "don't check for new versions of glibc" , 0 , False )
+
 # experimental features
 add_option( "mm", "use main memory instead of memory mapped files" , 0 , True )
 add_option( "asio" , "Use Asynchronous IO (NOT READY YET)" , 0 , True )
@@ -169,6 +181,11 @@
 add_option( "heapcheck", "link to heap-checking malloc-lib and look for memory leaks during tests" , 0 , False )
 
 add_option("smokedbprefix", "prefix to dbpath et al. for smoke tests", 1 , False )
+
+for shortName in getThirdPartyShortNames():
+    add_option( "use-system-" + shortName , "use system version of library " + shortName , 0 , True )
+
+add_option( "use-system-all" , "use all system libraries " + shortName , 0 , True )
 
 # --- environment setup ---
 
@@ -327,7 +344,7 @@
 
 # ------    SOURCE FILE SETUP -----------
 
-commonFiles = Split( "pch.cpp buildinfo.cpp db/indexkey.cpp db/jsobj.cpp bson/oid.cpp db/json.cpp db/lasterror.cpp db/nonce.cpp db/queryutil.cpp db/querypattern.cpp db/projection.cpp shell/mongo.cpp db/security_common.cpp db/security_commands.cpp" )
+commonFiles = Split( "pch.cpp buildinfo.cpp db/indexkey.cpp db/jsobj.cpp bson/oid.cpp db/json.cpp db/lasterror.cpp db/nonce.cpp db/queryutil.cpp db/querypattern.cpp db/projection.cpp shell/mongo.cpp" )
 commonFiles += [ "util/background.cpp" , "util/util.cpp" , "util/file_allocator.cpp" ,
                  "util/assert_util.cpp" , "util/log.cpp" , "util/ramlog.cpp" , "util/md5main.cpp" , "util/base64.cpp", "util/concurrency/vars.cpp", "util/concurrency/task.cpp", "util/debug_util.cpp",
                  "util/concurrency/thread_pool.cpp", "util/password.cpp", "util/version.cpp", "util/signal_handlers.cpp",  
@@ -343,23 +360,4 @@
 coreServerFiles = [ "util/net/message_server_port.cpp" , 
                     "client/parallel.cpp" , "db/common.cpp", 
                     "util/net/miniwebserver.cpp" , "db/dbwebserver.cpp" , 
-                    "db/matcher.cpp" , "db/dbcommands_generic.cpp" , "db/dbmessage.cpp" ]
-
-mmapFiles = [ "util/mmap.cpp" ]
-
-if has_option( "mm" ):
-    mmapFiles += [ "util/mmap_mm.cpp" ]
-elif os.sys.platform == "win32":
-    mmapFiles += [ "util/mmap_win.cpp" ]
-else:
-    mmapFiles += [ "util/mmap_posix.cpp" ]
-
-coreServerFiles += mmapFiles
-
-processInfoFiles = [ "util/processinfo.cpp" ]
-
-if os.path.exists( "util/processinfo_" + os.sys.platform + ".cpp" ):
-    processInfoFiles += [ "util/processinfo_" + os.sys.platform + ".cpp" ]
-elif os.sys.platform == "linux3":
-    processInfoFiles += [ "util/processinfo_linux2.cpp" ]
-else:
+                    "db/matcher.cpp" , "db/dbcommands_generic.cpp" , "db/dbmessage.cpp",

=== debian/changelog ===
mongodb (1:2.0.2-4ubuntu1) precise; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Mark mongodb-{server,client,dev} as replacing mongodb to be able to
      upgrade from Lucid
    - Add upstart job:
      - add debian/mongodb-server.mongodb.upstart

 -- Jani Monoses <jani@ubuntu.com>  Thu, 09 Feb 2012 13:33:14 +0200

mongodb (1:2.0.2-4) unstable; urgency=low

  * Move socket from /tmp to /var/run/mongodb (Closes: #658177)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Wed, 01 Feb 2012 14:53:12 +0100

mongodb (1:2.0.2-3) unstable; urgency=low

  * Describe jsonArray option for mongoimport in manpage (Closes: 656444)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu, 19 Jan 2012 14:11:14 +0100

mongodb (1:2.0.2-2) unstable; urgency=low

  * added logrotate for mongodb-server (Closes: #656065)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Mon, 16 Jan 2012 10:46:36 +0100

mongodb (1:2.0.2-1) unstable; urgency=low

  * New upstream release 2.0.2
    https://jira.mongodb.org/browse/SERVER/fixforversion/10991

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu, 15 Dec 2011 11:26:24 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Antonin Kral <A.Kral@sh.cvut.cz>
 Uploaders: Roberto C. Sanchez <roberto@connexer.com>, Jérémy Lal <kapouer@melix.org>
-Build-Depends: debhelper (>= 7), cdbs (>= 0.4.73~), libpcre3, libpcre3-dev, scons (>= 2.1), libreadline-dev, libboost-dev, libboost-thread-dev, libboost-filesystem-dev, libboost-program-options-dev, libboost-date-time-dev, python-pymongo
+Build-Depends: debhelper (>= 7), cdbs (>= 0.4.73~), libpcre3, libpcre3-dev, scons, libreadline-dev, libboost-dev, libboost-thread-dev, libboost-filesystem-dev, libboost-program-options-dev, libboost-date-time-dev, python-pymongo
 Standards-Version: 3.9.2
 Vcs-Git: git://github.com/bobek/mongo-debian.git
 Vcs-Browser: https://github.com/bobek/mongo-debian
@@ -35,6 +35,7 @@
 Package: mongodb-server
 Architecture: i386 amd64
 Depends: mongodb-clients, ${shlibs:Depends}, ${misc:Depends}, adduser
+Replaces: mongodb (<= 1:1.4.2-2)
 Description: object/document-oriented database (server package)
  MongoDB is a high-performance, open source, schema-free
  document-oriented  data store that's easy to deploy, manage
@@ -58,6 +59,7 @@
 Package: mongodb-clients
 Architecture: i386 amd64
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Replaces: mongodb (<= 1:1.4.2-2)
 Description: object/document-oriented database (client apps)
  MongoDB is a high-performance, open source, schema-free
  document-oriented  data store that's easy to deploy, manage
@@ -82,6 +84,7 @@
 Section: libdevel
 Architecture: i386 amd64
 Depends: mongodb-server, libboost-dev, ${shlibs:Depends}, ${misc:Depends}
+Replaces: mongodb (<= 1:1.4.2-2)
 Description: object/document-oriented database (development)
  MongoDB is a high-performance, open source, schema-free
  document-oriented  data store that's easy to deploy, manage

## mongodb 2.0.3

=== SConstruct ===
--- 
+++ 
@@ -25,6 +25,17 @@
 import stat
 from buildscripts import utils
 
+
+def _rpartition(string, sep):
+    """A replacement for str.rpartition which is missing in Python < 2.5
+    """
+    idx = string.rfind(sep)
+    if idx == -1:
+        return '', '', string
+    return string[:idx], sep, string[idx + 1:]
+
+
+
 buildscripts.bb.checkOk()
 
 def findSettingsSetup():
@@ -38,7 +49,7 @@
         if not x.endswith( ".py" ) or x.find( "#" ) >= 0:
             continue
          
-        lst.append( x.rpartition( "." )[0] )
+        lst.append( _rpartition( x, "." )[0] )
     return lst
 
 
@@ -334,6 +345,7 @@
         self.clientTestsDir = "client/examples/"
         
 installSetup = InstallSetup()
+env["installSetup"] = installSetup
 if distBuild:
     installSetup.bannerDir = "distsrc"
 
@@ -358,6 +370,3 @@
 
 coreDbFiles = [ "db/commands.cpp" ]
 coreServerFiles = [ "util/net/message_server_port.cpp" , 
-                    "client/parallel.cpp" , "db/common.cpp", 
-                    "util/net/miniwebserver.cpp" , "db/dbwebserver.cpp" , 
-                    "db/matcher.cpp" , "db/dbcommands_generic.cpp" , "db/dbmessage.cpp",

=== debian/changelog ===
mongodb (1:2.0.3-2) unstable; urgency=low

  * Enable journaling by default (Closes:#664080)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu, 15 Mar 2012 16:48:06 +0100

mongodb (1:2.0.3-1) unstable; urgency=low

  * New upstream release 2.0.2
    https://jira.mongodb.org/browse/SERVER/fixforversion/11001
  * added debian/copat
  * added Replaces clause from Ubuntu patch

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu, 01 Mar 2012 14:14:34 +0100

mongodb (1:2.0.2-5) unstable; urgency=low

  * Allow parallel build, patch courtesy of Andre Ferraz
    <deferraz@terra.com.br> (Closes:#646759)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu, 16 Feb 2012 10:25:06 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Antonin Kral <A.Kral@sh.cvut.cz>
 Uploaders: Roberto C. Sanchez <roberto@connexer.com>, Jérémy Lal <kapouer@melix.org>
 Build-Depends: debhelper (>= 7), cdbs (>= 0.4.73~), libpcre3, libpcre3-dev, scons, libreadline-dev, libboost-dev, libboost-thread-dev, libboost-filesystem-dev, libboost-program-options-dev, libboost-date-time-dev, python-pymongo
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Vcs-Git: git://github.com/bobek/mongo-debian.git
 Vcs-Browser: https://github.com/bobek/mongo-debian
 Homepage: http://www.mongodb.org

## mongodb 2.0.4

=== debian/changelog ===
mongodb (1:2.0.4-1ubuntu2.1) precise-security; urgency=low

  * SECURITY UPDATE: Remote code execution vulnerability in Spidermonkey
    JavaScript engine (LP: #1160893).
    - d/p/CVE-2013-1892.1.patch: Avoid raw pointers for SM's nativeHelper.
      Cherry picked from upstream VCS.
    - d/p/CVE-2013-1892.2.patch: Cast id to double before converting to
      JS. Cherry picked from upstream VCS.
    - https://jira.mongodb.org/browse/SERVER-9124
    - CVE-2013-1892

 -- James Page <james.page@ubuntu.com>  Thu, 28 Mar 2013 10:04:28 +0000

mongodb (1:2.0.4-1ubuntu2) precise; urgency=low

  * debian/control: enable armhf and armel builds.
  * debian/patches/0009-arm-support.patch: Signedness and alignment
    fixes to make the smoketest pass on ARM.

 -- Jani Monoses <jani@ubuntu.com>  Wed, 04 Apr 2012 12:49:34 +0300

mongodb (1:2.0.4-1ubuntu1) precise; urgency=low

  * Merge bugfix release from Debian unstable, remaining change:
    - add debian/mongodb-server.mongodb.upstart

 -- Jani Monoses <jani@ubuntu.com>  Tue, 03 Apr 2012 21:38:06 +0300

mongodb (1:2.0.4-1) unstable; urgency=low

  * New upstream release 2.0.4
    https://jira.mongodb.org/browse/SERVER/fixforversion/11107

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Fri, 30 Mar 2012 21:41:35 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: mongodb
 Section: database
 Priority: optional
-Maintainer: Antonin Kral <A.Kral@sh.cvut.cz>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Antonin Kral <A.Kral@sh.cvut.cz>
 Uploaders: Roberto C. Sanchez <roberto@connexer.com>, Jérémy Lal <kapouer@melix.org>
 Build-Depends: debhelper (>= 7), cdbs (>= 0.4.73~), libpcre3, libpcre3-dev, scons, libreadline-dev, libboost-dev, libboost-thread-dev, libboost-filesystem-dev, libboost-program-options-dev, libboost-date-time-dev, python-pymongo
 Standards-Version: 3.9.3
@@ -10,7 +11,7 @@
 Homepage: http://www.mongodb.org
 
 Package: mongodb
-Architecture: i386 amd64
+Architecture: i386 amd64 armel armhf
 Depends: mongodb-server, mongodb-dev, ${shlibs:Depends}, ${misc:Depends}
 Description: object/document-oriented database (metapackage)
  MongoDB is a high-performance, open source, schema-free
@@ -33,7 +34,7 @@
  This is a metapackage that depends on all the mongodb parts.
 
 Package: mongodb-server
-Architecture: i386 amd64
+Architecture: i386 amd64 armel armhf
 Depends: mongodb-clients, ${shlibs:Depends}, ${misc:Depends}, adduser
 Replaces: mongodb (<= 1:1.4.2-2)
 Description: object/document-oriented database (server package)
@@ -57,7 +58,7 @@
  This package contains the server itself.
 
 Package: mongodb-clients
-Architecture: i386 amd64
+Architecture: i386 amd64 armel armhf
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: mongodb (<= 1:1.4.2-2)
 Description: object/document-oriented database (client apps)
@@ -82,7 +83,7 @@
 
 Package: mongodb-dev
 Section: libdevel
-Architecture: i386 amd64
+Architecture: i386 amd64 armel armhf
 Depends: mongodb-server, libboost-dev, ${shlibs:Depends}, ${misc:Depends}
 Replaces: mongodb (<= 1:1.4.2-2)
 Description: object/document-oriented database (development)

=== debian/rules ===
--- 
+++ 
@@ -6,12 +6,16 @@
 
 DEB_DH_INSTALLINIT_ARGS = --name=mongodb
 
-DEB_SCONS_OPTIONS := 
+DEB_SCONS_OPTIONS :=
 ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
 	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
 endif
 ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
 	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
+endif
+ifneq (,$(findstring parallel,$(DEB_BUILD_OPTIONS)))
+       PROCS=$(subst parallel=,,$(DEB_BUILD_OPTIONS))
+       DEB_SCONS_OPTIONS += -j$(PROCS)
 endif
 
 DEB_SCONS_BUILD_TARGET = all

## mongodb 2.0.6

=== debian/changelog ===
mongodb (1:2.0.6-1ubuntu4) quantal; urgency=low

  * Disable armel, on *all* packages, because of 1019098.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Wed, 04 Jul 2012 09:30:51 +0100

mongodb (1:2.0.6-1ubuntu3) quantal; urgency=low

  * Disable armel, because of 1019098.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Wed, 04 Jul 2012 08:56:40 +0100

mongodb (1:2.0.6-1ubuntu2) quantal; urgency=low

  * Disable test-suite on arm-any, because smoketest fails.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Tue, 26 Jun 2012 23:50:10 +0100

mongodb (1:2.0.6-1ubuntu1) quantal-proposed; urgency=low

  * Merge from debian unstable (LP: #1017685), remaining changes:
    - debian/control: enable armhf and armel builds.
    - debian/patches/0009-arm-support.patch: Signedness and alignment
    fixes to make the smoketest pass on ARM.
    - add debian/mongodb-server.mongodb.upstart

  * Part of boost1.49 transition
  
 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Tue, 26 Jun 2012 23:50:10 +0100

mongodb (1:2.0.6-1) unstable; urgency=low

  * New upstream release 2.0.6
    https://jira.mongodb.org/browse/SERVER/fixforversion/11165

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Tue, 05 Jun 2012 19:52:28 +0200

mongodb (1:2.0.5-2) unstable; urgency=low

  * Removed mongodb-server as dependency of mongodb-dev (Closes:#672634)

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Sun, 27 May 2012 13:00:38 +0200

mongodb (1:2.0.5-1) unstable; urgency=low

  * New upstream release 2.0.5
    https://jira.mongodb.org/browse/SERVER/fixforversion/11137

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Thu, 10 May 2012 07:05:43 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Homepage: http://www.mongodb.org
 
 Package: mongodb
-Architecture: i386 amd64 armel armhf
+Architecture: i386 amd64 armhf
 Depends: mongodb-server, mongodb-dev, ${shlibs:Depends}, ${misc:Depends}
 Description: object/document-oriented database (metapackage)
  MongoDB is a high-performance, open source, schema-free
@@ -26,7 +26,7 @@
     * Replication and fail-over support
     * Efficient storage of binary data including large
       objects (e.g. videos)
-    * Auto-sharding for cloud-level scalability (Q209)
+    * Auto-sharding for cloud-level scalability
  .
  High performance, scalability, and reasonable depth of
  functionality are the goals for the project.
@@ -34,7 +34,7 @@
  This is a metapackage that depends on all the mongodb parts.
 
 Package: mongodb-server
-Architecture: i386 amd64 armel armhf
+Architecture: i386 amd64 armhf
 Depends: mongodb-clients, ${shlibs:Depends}, ${misc:Depends}, adduser
 Replaces: mongodb (<= 1:1.4.2-2)
 Description: object/document-oriented database (server package)
@@ -50,7 +50,7 @@
     * Replication and fail-over support
     * Efficient storage of binary data including large
       objects (e.g. videos)
-    * Auto-sharding for cloud-level scalability (Q209)
+    * Auto-sharding for cloud-level scalability
  .
  High performance, scalability, and reasonable depth of
  functionality are the goals for the project.
@@ -58,7 +58,7 @@
  This package contains the server itself.
 
 Package: mongodb-clients
-Architecture: i386 amd64 armel armhf
+Architecture: i386 amd64 armhf
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: mongodb (<= 1:1.4.2-2)
 Description: object/document-oriented database (client apps)
@@ -74,7 +74,7 @@
     * Replication and fail-over support
     * Efficient storage of binary data including large
       objects (e.g. videos)
-    * Auto-sharding for cloud-level scalability (Q209)
+    * Auto-sharding for cloud-level scalability
  .
  High performance, scalability, and reasonable depth of
  functionality are the goals for the project.
@@ -83,8 +83,9 @@
 
 Package: mongodb-dev
 Section: libdevel
-Architecture: i386 amd64 armel armhf
-Depends: mongodb-server, libboost-dev, ${shlibs:Depends}, ${misc:Depends}
+Architecture: i386 amd64 armhf
+Depends: libboost-dev, ${shlibs:Depends}, ${misc:Depends}
+Suggests: mongodb-server
 Replaces: mongodb (<= 1:1.4.2-2)
 Description: object/document-oriented database (development)
  MongoDB is a high-performance, open source, schema-free
@@ -99,7 +100,7 @@
     * Replication and fail-over support
     * Efficient storage of binary data including large
       objects (e.g. videos)
-    * Auto-sharding for cloud-level scalability (Q209)
+    * Auto-sharding for cloud-level scalability
  .
  High performance, scalability, and reasonable depth of
  functionality are the goals for the project.

=== debian/rules ===
--- 
+++ 
@@ -20,7 +20,10 @@
 
 DEB_SCONS_BUILD_TARGET = all
 DEB_SCONS_INSTALL_OPTIONS += --prefix=$(CURDIR)/debian/tmp/usr --full
+#TODO FIXME smoketest suite on arm-any
+ifeq (,$(filter armel armhf, $(DEB_HOST_ARCH)))
 DEB_SCONS_CHECK_TARGET = --smokedbprefix=$(CURDIR)/debian/tmp-test smoke
+endif
 
 clean::
 	find . -name "*.pyc" -delete

## mongodb 2.2.3

=== debian/changelog ===
mongodb (1:2.2.3-0ubuntu1) raring; urgency=low

  * Re-sync with Debian unstable:
    - d/control: Enable armhf architecture.
    - d/mongodb-server.mongodb.upstart: Add upstart configuration.
    - d/rules: Disable smoke tests on arm architectures.
  * New upstream release (LP: #1079119).
    - d/p/SConscript.client.patch: fixup install of client libraries.
    - d/p/0001-install-libs-to-usr-lib-not-usr-lib64-Closes-588557.patch:
      Install libraries to lib not lib64.
    - d/p/arm-support.patch: Re-enable support for ARM architecture. Thanks
      to Jon Masters for this patch.
  * Switch to using distro provided libraries and tcmalloc for improved
    memory allocation performance:
    - d/control: Added BD's on libgoogle-perftools-dev, libsnappy-dev.
    - d/rules: use system libraries (aside from spidermonkey), use tcmalloc
      for memory allocation on x86 archs.
  * d/mongodb-server.mongodb.upstart: General tidy, ensure that MongoDB stops
    on runlevel 1 (LP: #820689).
  * d/*.lintian-overrides: Dropped - no longer required.
  * d/rules: Stop stripping binaries as part of build process so that ddebs
    are produced for Ubuntu.

 -- James Page <james.page@ubuntu.com>  Mon, 04 Mar 2013 20:42:16 +0000

mongodb (1:2.2.2-1) unstable; urgency=low

  * New upstream release 2.2.2
    https://jira.mongodb.org/browse/SERVER/fixforversion/11886

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Wed, 28 Nov 2012 09:34:58 +0100

mongodb (1:2.2.0-1) unstable; urgency=low

  * New upstream release 2.2.0
    http://jira.mongodb.org/browse/SERVER/fixforversion/11496
    http://blog.mongodb.org/post/30451575525/mongodb-2-2-released

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Wed, 29 Aug 2012 21:06:20 +0200

mongodb (1:2.0.7-1) unstable; urgency=low

  * New upstream release 2.0.7
    https://jira.mongodb.org/browse/SERVER/fixforversion/11201

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Fri, 10 Aug 2012 14:58:19 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Antonin Kral <A.Kral@sh.cvut.cz>
 Uploaders: Roberto C. Sanchez <roberto@connexer.com>, Jérémy Lal <kapouer@melix.org>
-Build-Depends: debhelper (>= 7), cdbs (>= 0.4.73~), libpcre3, libpcre3-dev, scons, libreadline-dev, libboost-dev, libboost-thread-dev, libboost-filesystem-dev, libboost-program-options-dev, libboost-date-time-dev, python-pymongo
+Build-Depends: debhelper (>= 9), cdbs (>= 0.4.73~), libpcre3, libpcre3-dev, scons, libreadline-dev, libboost-dev, libboost-thread-dev, libboost-filesystem-dev, libboost-program-options-dev, libboost-date-time-dev, python-pymongo, libsnappy-dev, libgoogle-perftools-dev [amd64 i386]
 Standards-Version: 3.9.3
 Vcs-Git: git://github.com/bobek/mongo-debian.git
 Vcs-Browser: https://github.com/bobek/mongo-debian

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/scons.mk
include /usr/share/cdbs/1/rules/debhelper.mk

DEB_DH_INSTALLINIT_ARGS = --name=mongodb

DEB_SCONS_OPTIONS :=

# Ubuntu specific build options
ifeq ($(shell dpkg-vendor --derives-from ubuntu && echo ubuntu),ubuntu)
# Don't strip binaries - this is handled automatically in ubuntu
DEB_SCONS_OPTIONS += --nostrip

ifeq ($(shell grep -c -E '^Build-Depends:(.*,)?[[:space:]]*libboost-dev([[:space:]]|,|$$)' debian/control),1)
	DEB_SCONS_OPTIONS += --use-system-boost
endif #boost

ifeq ($(shell grep -c -E '^Build-Depends:(.*,)?[[:space:]]*libpcre3-dev([[:space:]]|,|$$)' debian/control),1)
	DEB_SCONS_OPTIONS += --use-system-pcre
endif #pcre

ifeq ($(shell grep -c -E '^Build-Depends:(.*,)?[[:space:]]*libssl-dev([[:space:]]|,|$$)' debian/control),1)
	DEB_SCONS_OPTIONS += --ssl
endif #ssl

ifeq ($(shell grep -c -E '^Build-Depends:(.*,)?[[:space:]]*libsnappy-dev([[:space:]]|,|$$)' debian/control),1)
	DEB_SCONS_OPTIONS += --use-system-snappy
endif #snappy

ifeq ($(filter armhf, $(DEB_HOST_ARCH)),)
ifeq ($(shell grep -c -E '^Build-Depends:(.*,)?[[:space:]]*libgoogle-perftools-dev([[:space:]]|,|$$)' debian/control),1)
	# Enable gperftools on x86 archs
	DEB_SCONS_OPTIONS += --allocator=tcmalloc --use-system-tcmalloc
endif #gperftools
endif #!armhf

endif #ubuntu

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS += --d=DEBUGBUILD
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS += --d=DEBUGBUILD
endif
ifneq (,$(findstring parallel,$(DEB_BUILD_OPTIONS)))
	PROCS=$(subst parallel=,,$(DEB_BUILD_OPTIONS))
	DEB_SCONS_OPTIONS += -j$(PROCS)
endif

DEB_SCONS_BUILD_TARGET = all
DEB_SCONS_INSTALL_OPTIONS += --prefix=$(CURDIR)/debian/tmp/usr --full
#TODO FIXME smoketest suite on armhf
ifeq ($(filter armhf, $(DEB_HOST_ARCH)),)
DEB_SCONS_CHECK_TARGET = --smokedbprefix=$(CURDIR)/debian/tmp-test smoke
endif

clean::
	find . -name "*.pyc" -delete
	rm -f buildinfo.cpp
	rm -rf debian/tmp-test
	rm -rf .scons

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

# examination of the downloads page content as the directory listing is not allowed anymore
# Forced regexp to match only to the current stable release
http://www.mongodb.org/display/DOCS/Downloads \
  http://.*mongodb\.org/src/mongodb-src-r(2\.2[\d\.]+)\.tar\.gz

## mongodb 2.2.4~rc0

=== debian/changelog ===
mongodb (1:2.2.4~rc0-0ubuntu1) raring; urgency=low

  * New upstream bugfix release:
    - Includes fix for JavaScript remote code execution security
      issue (LP: #1160893).
      CVE-2013-1892

 -- James Page <james.page@ubuntu.com>  Thu, 28 Mar 2013 09:13:20 +0000

mongodb (1:2.2.3-0ubuntu4) raring; urgency=low

  * Enable SSL support:
    - d/control: Add libssl-dev to BD's.
    - d/mongodb.conf: Add example SSL configuration options.

 -- James Page <james.page@ubuntu.com>  Wed, 27 Mar 2013 10:50:37 +0000

mongodb (1:2.2.3-0ubuntu3) raring; urgency=low

  * d/p/double-alignment.patch: add another double alignment correction
    case.
  * d/rules: re-enable smoke tests on armhf.

 -- Robie Basak <robie.basak@canonical.com>  Wed, 20 Mar 2013 13:36:51 -0400

mongodb (1:2.2.3-0ubuntu2) raring; urgency=low

  [ Robie Basak ]
  * Fix support for ARM:
    - d/p/arm-support.patch: fix atomic operation semantics bugs.
    - d/p/double-alignment.patch: workaround for unaligned double accesses
      on ARM causing SIGBUS.
  * d/rules: fix parallel build parsing in DEB_BUILD_OPTIONS.

  [ James Page ]
  * d/watch: Update version match to look for all releases.

 -- James Page <james.page@ubuntu.com>  Wed, 20 Mar 2013 10:18:36 +0000
